#include "main.h"

// Include the generated source index.
// NOTE: Keep the project name and this path in sync.
#include "Generated/ExternalReflection/Generated.ocppindex"
#include <iostream>
#include <conio.h>

// usings
using std::cout;
using std::endl;

// Entry point into the application.
int main()
{
	// usings for opcpp
	using opcpp::registration::class_tracker;
	using opcpp::registration::class_type;
	using opcpp::fields::data_field;

 	class_type* type = class_tracker::get_type("Person");
 
 	if (type)
 	{
 		size_t num = type->get_field_count();
 
		// Print opclass name and number of fields.
 		cout << "Found opclass '" << type->get_name() << "'" << endl << endl;
 		cout << '\t' << num << " fields" << endl;
 		cout << "\t---------" << endl << endl;
 
		// Print out the names of each field.
 		for (size_t i = 0; i < num; i++)
		{
			data_field* field = type->get_field(i);

 			cout << '\t' << type->get_field(i)->member_name();

			if ( field->is_transient() )
				cout << " (transient)";

			cout << endl;
		}
 	}
	
	_getch();

	return 0;
}


